//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DemoUnit.h"
#include "Bffolder.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Bffolder"
#pragma link "bffolder"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
//  Bffolder1 = new TBffolder (this);
//  Bffolder1->OnInitialized = Bffolder1Initialized;
//  Bffolder1->OnSelectionChanged = Bffolder1SelectionChanged;
//  Bffolder1->OnValidateFailed = Bffolder1ValidateFailed;

  ComboBox1->ItemIndex = Bffolder1->RootDir;

  CheckBox1->Checked = Bffolder1->Options.Contains (bffBrowseForComputer);
  CheckBox2->Checked = Bffolder1->Options.Contains (bffBrowseForPrinter);
  CheckBox3->Checked = Bffolder1->Options.Contains (bffDontGoBelowDomain);
  CheckBox4->Checked = Bffolder1->Options.Contains (bffReturnFSAncestors);
  CheckBox5->Checked = Bffolder1->Options.Contains (bffReturnOnlyFSDirs);
  CheckBox6->Checked = Bffolder1->Options.Contains (bffStatusText);

  CheckBox7->Checked = Bffolder1->EnableOK;

  Edit6->Text = AnsiString(HIWORD(Bffolder1->DllVersion)) + "." +
                AnsiString(LOWORD(Bffolder1->DllVersion));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if (CheckBox1->Checked)
    Bffolder1->Options << bffBrowseForComputer;
  else
    Bffolder1->Options >> bffBrowseForComputer;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  if (CheckBox2->Checked)
    Bffolder1->Options << bffBrowseForPrinter;
  else
    Bffolder1->Options >> bffBrowseForPrinter;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
  if (CheckBox3->Checked)
    Bffolder1->Options << bffDontGoBelowDomain;
  else
    Bffolder1->Options >> bffDontGoBelowDomain;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
  if (CheckBox4->Checked)
    Bffolder1->Options << bffReturnFSAncestors;
  else
    Bffolder1->Options >> bffReturnFSAncestors;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox5Click(TObject *Sender)
{
  if (CheckBox5->Checked)
    Bffolder1->Options << bffReturnOnlyFSDirs;
  else
    Bffolder1->Options >> bffReturnOnlyFSDirs;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox6Click(TObject *Sender)
{
  if (CheckBox6->Checked)
    Bffolder1->Options << bffStatusText;
  else
    Bffolder1->Options >> bffStatusText;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox8Click(TObject *Sender)
{
  if (CheckBox8->Checked)
    Bffolder1->Options << bffBrowseIncludeFiles;
  else
    Bffolder1->Options >> bffBrowseIncludeFiles;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox9Click(TObject *Sender)
{
  if (CheckBox9->Checked)
    Bffolder1->Options << bffEditBox;
  else
    Bffolder1->Options >> bffEditBox;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox10Click(TObject *Sender)
{
  if (CheckBox10->Checked)
    Bffolder1->Options << bffValidate;
  else
    Bffolder1->Options >> bffValidate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  Bffolder1->RootDir = (TBffRootDir)ComboBox1->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox7Click(TObject *Sender)
{
  Bffolder1->EnableOK = CheckBox7->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
  Bffolder1->Title       = Edit4->Text;
  Bffolder1->Caption     = Edit3->Text;
  Bffolder1->StatusText  = Edit5->Text;
  Bffolder1->SelectedDir = Edit2->Text;

  if (Bffolder1->Execute ())
  {
    Edit1->Text = Bffolder1->DisplayName;
    Edit2->Text = Bffolder1->SelectedDir;
    Edit3->Text = Bffolder1->Caption;
    Edit5->Text = Bffolder1->StatusText;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Bffolder1SelectionChanged(TObject *Sender,
      AnsiString NewSel)
{
  EventLog->Items->Add ("OnSelectionChanged: " + NewSel);

  if (IsInitialized)
    Bffolder1->StatusText = Bffolder1->DisplayName;
//    Bffolder1->StatusText = NewSel;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Bffolder1ValidateFailed(TObject *Sender,
          AnsiString InvalidName, bool& Continue)
{
  int nResult;
  nResult = Application->MessageBox (InvalidName.c_str(), "Invalid Selection:",
              MB_OKCANCEL | MB_ICONEXCLAMATION);
  Continue = (nResult == IDOK);
  EventLog->Items->Add ("OnValidateFailed: " + InvalidName + " / " + (int)Continue);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Bffolder1Initialized(TObject *Sender)
{
  EventLog->Items->Add ("OnInitialized");
  IsInitialized = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnClearClick(TObject *Sender)
{
  EventLog->Items->Clear ();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  //delete Bffolder1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EventLogClick(TObject *Sender)
{
  EventLog->Hint = EventLog->Items->Strings[EventLog->ItemIndex];
}
//---------------------------------------------------------------------------

